<?php
class CuestionariodetalleModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Cuestionariodetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL cuedet_crear(?,?,?,?)");
            $stm->execute(array(
                $data->__get('cuestionario_Id'),
                $data->__get('pregunta_Id'),
                $data->__get('nComDetOrden'),
                $data->__get('nComDetPorcentaje'),
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    public function Listar_preguntas()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pre_listarC(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $com = new Pregunta();
                $com->__SET('pregunta_Id', $r->pregunta_Id);
                $com->__SET('sPreDescripcion', $r->sPreDescripcion);

                $result[] = $com;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //listar cuestionario para modificar y ver //por modificar
    public function ListarCuestionarioDetalle($cuestionario_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("call cuedet_listarunico($cuestionario_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $com = [
                    "cuestionario_Id" => $r->cuestionario_Id,
                    "pregunta_Id" => $r->pregunta_Id,
                    "sPreDescripcion" => $r->sPreDescripcion,
                    "nComDetOrden" => $r->nComDetOrden,
                    "nComDetPorcentaje" => $r->nComDetPorcentaje,
                ];

                array_push($result, $com);
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Cuestionariodetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("DELETE FROM cuestionariodetalle WHERE cuestionario_Id = ? ");
            $stm->execute(array($data->__get('cuestionario_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Cuestionariodetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL cuedet_crear(?,?,?,?)");
            $stm->execute(array(
                $data->__get('cuestionario_Id'),
                $data->__get('pregunta_Id'),
                $data->__get('nComDetOrden'),
                $data->__get('nComDetPorcentaje'),
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}
