<?php
class EvaluaciondetalleModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function GuardarDet(Evaluaciondetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL evadet_crear(?,?,?,?,?,?,@evaluaciondetalle_Id)");
            $stm->execute(array(
                $data->__get('nEvaDetEvaluacion_Id'),
                $data->__get('nEvaDetEvaluado_Id'),
                $data->__get('nEvaDetCuestionario_Id'),
                $data->__get('nEvaDetEstado'),
                $data->__get('nEvaDetAvance'),
                $data->__get('nEvaDetUsuario_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EditarDetalle($id, $evaluacion_id, $evaluado_id, $cuestionario_id, $estado, $avance, $usuario){
        try {
            $stm = $this->pdo->prepare("CALL evadet_editar(?,?,?,?,?,?,?)");
            $stm->execute([$id, $evaluacion_id, $evaluado_id, $cuestionario_id, $estado, $avance, $usuario]);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($evaluacion_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL evadet_listar(?)");
            $stm->execute([$evaluacion_Id]); 

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $pro = array(
                    'evaluaciondetalle_Id' => $r->evaluaciondetalle_Id,
                    'nEvaDetEvaluacion_Id' => $r->nEvaDetEvaluacion_Id,
                    'nEvaDetEvaluado_Id' => $r->nEvaDetEvaluado_Id,
                    'Evaluado' => $r->Evaluado,
                    'nEvaDetCuestionario_Id' => $r->nEvaDetCuestionario_Id,
                    'Cuestionario' => $r->Cuestionario,
                );
                $result[] = $pro;
            }

            return $result;
        } catch (Exception $e) {
            die("Error al buscar detalles: " . $e->getMessage());
        }
    }

    public function Eliminar(Evaluaciondetalle $data)
    {
        try {
            $stm = $this->pdo->prepare("DELETE FROM evaluaciondetalle WHERE evaluaciondetalle_Id = ? ");
            $stm->execute(array($data->__get('evaluaciondetalle_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function OcultarEvaluacionDetalle($id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare('UPDATE evaluaciondetalle SET nEvaDetEstado=0 WHERE evaluaciondetalle_Id = ?');
            $stm->execute([$id]);
            
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}
