<?php
class PreguntaModel
{
    private $pdo;

    public function __CONSTRUCT()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function Listar_comportamientos()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL comdet_listar_todos()");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $com = new Comportamiento();
                $com->__SET('competenciadetalle_Id', $r->competenciadetalle_Id);
                $com->__SET('competencia_Id', $r->competencia_Id);
                $com->__SET('sComDetNombre', $r->sComDetNombre);

                $result[] = $com;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pre_listarC(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $pre = new Pregunta();
                $pre->__SET('Pregunta_Id', $r->pregunta_Id);
                $pre->__SET('competenciadetalle_Id', $r->competenciadetalle_Id);
                $pre->__SET('sPreCodigo', $r->sPreCodigo);
                $pre->__SET('sPreDescripcion', $r->sPreDescripcion);
                $pre->__SET('nPreEstado', $r->nPreEstado);
                $pre->__SET('nPreEliminado', $r->nPreEliminado);
                $pre->__SET('nPreUsuario_Id', $r->nPreUsuario_Id);
                $pre->__SET('dPreFecha_Act', $r->dPreFecha_Act);
                $result[] = $pre;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($pregunta_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pre_listarC(?)");
            $stm->execute([$pregunta_Id]);

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $pre = new Pregunta();
                $pre->__SET('Pregunta_Id', $r->pregunta_Id);
                $pre->__SET('competenciadetalle_Id', $r->competenciadetalle_Id);
                $pre->__SET('sPreCodigo', $r->sPreCodigo);
                $pre->__SET('sPreDescripcion', $r->sPreDescripcion);
                $pre->__SET('nPreEstado', $r->nPreEstado);
                $pre->__SET('nPreEliminado', $r->nPreEliminado);
                $pre->__SET('nPreUsuario_Id', $r->nPreUsuario_Id);
                $pre->__SET('dPreFecha_Act', $r->dPreFecha_Act);
                $result[] = $pre;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Pregunta $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL pre_crear(?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__GET('competenciadetalle_Id'),
                $data->__GET('sPreCodigo'),
                $data->__GET('sPreDescripcion'),
                $data->__GET('nPreEstado'),
                $data->__GET('nPreEliminado'),
                $data->__GET('nPreUsuario_Id'),
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>    <i class="icon fa fa-check"></i> Información Guardada.</h4>
                    La información fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Pregunta $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL pre_editar(?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__GET('Pregunta_Id'),
                $data->__GET('competenciadetalle_Id'),
                $data->__GET('sPreCodigo'),
                $data->__GET('sPreDescripcion'),
                $data->__GET('nPreEstado'),
                $data->__GET('nPreEliminado'),
                $data->__GET('nPreUsuario_Id'),
            ));
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>    <i class="icon fa fa-check"></i> Éxito.</h4>
                    Se modificó correctamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function Eliminar(Pregunta $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL pre_ocultar(?, ?)");
            $stm->execute([
                $data->__GET('Pregunta_Id'),
                $data->__GET('nPreUsuario_Id')
            ]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ObtenerCompetencia($competenciadetalle_Id)
    {
        try {
            $stm = $this->pdo->prepare("CALL pre_obt_competencia(?)");
            $stm->execute([$competenciadetalle_Id]);
            $result = $stm->fetch(PDO::FETCH_OBJ);
            return $result ? $result->sComNombre : null;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ObtenerCompetenciaDetalle($competenciadetalle_Id)
    {
        try {
            $stm = $this->pdo->prepare("CALL pre_obt_competenciadetalle(?)");
            $stm->execute([$competenciadetalle_Id]);
            $result = $stm->fetch(PDO::FETCH_OBJ);
            return $result ? $result->sComDetNombre : null; 
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

   
}
