<?php
class RangoEdadModel {
    private $pdo;

    public function __CONSTRUCT() {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eda_listarC(0)"); 
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $rango = new RangoEdad();
                $rango->__SET('edad_Id', $r->edad_Id);
                $rango->__SET('sEdaDescripcion', $r->sEdaDescripcion);
                $rango->__SET('nEdaEstado', $r->nEdaEstado);
                $result[] = $rango;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    public function Buscar($edad_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eda_listarC($edad_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $ran = new RangoEdad();
                $ran->__SET('edad_Id', $r->edad_Id);
                $ran->__SET('sEdaDescripcion', $r->sEdaDescripcion);
                $ran->__SET('nEdaEstado', $r->nEdaEstado);
                $ran->__SET('nEdaEliminado', $r->nEdaEliminado);
                $ran->__SET('nEdaUsuario_Id', $r->nEdaUsuario_Id);
                $ran->__SET('dEdaFecha_Act', $r->dEdaFecha_Act);
                $result[] = $ran;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(RangoEdad $data) {
        try {
            $stm = $this->pdo->prepare("CALL eda_crear(?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('sEdaDescripcion'),
                $data->__GET('nEdaEstado'),
                $data->__GET('nEdaEliminado'),
                $data->__GET('nEdaUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Información Guardada.</h4>
                    La información fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(RangoEdad $data) {
        try {
            $stm = $this->pdo->prepare("CALL eda_editar(?, ?, ?, ?, ?)"); 
            $stm->execute(array(
                $data->__GET('edad_Id'),
                $data->__GET('sEdaDescripcion'),
                $data->__GET('nEdaEstado'),
                $data->__GET('nEdaEliminado'),
                $data->__GET('nEdaUsuario_Id')
            ));

            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4><i class="icon fa fa-check"></i> Éxito, </h4>
                    Se modificó correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    public function Eliminar(RangoEdad $data){
        try {
            $stm = $this->pdo->prepare("CALL eda_ocultar(?, ?)");
            $stm->execute([
                $data->__GET('edad_Id'),
                $data->__GET('nEdaUsuario_Id')
            ]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
?>