<?php
class ResultadoModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                $res->__SET('Personal', $r->Personal);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                $res->__SET('Area', $r->Area);
                $res->__SET('Cargo', $r->Cargo);
                $res->__SET('Ano', $r->Ano);
                $res->__SET('Contrato', $r->Contrato);
                $res->__SET('Edad', $r->Edad);
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //listar resultados por fecha
    public function ListarDate($fechaInicio, $fechaFin){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL res_listarevaluadosAll('".date('Y-m-d', strtotime($fechaInicio))."','".date('Y-m-d', strtotime($fechaFin))."')");
            // $stm = $this->pdo->prepare("CALL res_listarevaluadosAll('2017-11-01','2017-12-31')");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $mov = new Resultado();
                $mov->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $mov->__SET('Fecha', date('d-m-Y', strtotime($r->Fecha)));
                $mov->__SET('Evaluado_Id', $r->Evaluado_Id);
                $mov->__SET('cuestionario_Id', $r->cuestionario_Id);
                $mov->__SET('Evaluado', $r->Evaluado);
                $mov->__SET('Evaluacion', $r->Evaluacion);
                $mov->__SET('Cuestionario', $r->Cuestionario);
                $mov->__SET('Area', $r->Area);
                $mov->__SET('Cargo', $r->Cargo);
                $mov->__SET('Ano', $r->Ano);
                $mov->__SET('Contrato', $r->Contrato);
                $mov->__SET('Edad', $r->Edad);
                $mov->__SET('Estado', $r->Estado);
                $mov->__SET('resultado_Id', $r->resultado_Id);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //listar de los usuarios

    public function ListarEvaUsu($Evaluado_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listar($Evaluado_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('Area', $r->Area);
                $res->__SET('Cargo', $r->Cargo);
                $res->__SET('Ano', $r->Ano);
                $res->__SET('Contrato', $r->Contrato);
                $res->__SET('Edad', $r->Edad);
                $res->__get('sResPregunta1');
                $res->__get('sResPregunta2');
                $res->__SET('nResEstado', $r->nResEstado);
                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $res->__SET('personal_Id', $r->personal_Id);
                
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function BuscarResultado($resultado_id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT * FROM resultado where resultado_id = ?");
            $stm->execute([$resultado_id]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ActualizarDatosGenerales(Resultado $data) {
        try {
            $sql = "UPDATE resultado SET
                        nArea_Id = ?, 
                        nCargo_Id = ?, 
                        nAno_Id = ?, 
                        nContratacion_Id = ?, 
                        nEdad_Id = ?, 
                        dResFecha_Act = now() 
                        WHERE resultado_id = ?";
    
            $stmt = $this->pdo->prepare($sql);
            // Ejecutamos la consulta con los parámetros correspondientes
            $stmt->execute(array(
                    $data->__get('nArea_Id'),
                    $data->__get('nCargo_Id'),
                    $data->__get('nAno_Id'),
                    $data->__get('nContratacion_Id'),
                    $data->__get('nEdad_Id'),
                    $data->__get('resultado_id') // el ID del resultado debe ser el último
                ));
    
            return $stmt->rowCount() > 0;
        } catch (Exception $e) {
            die($e->getMessage()); 
        }
    }

    public function ObtenerCuestionarioTest($cuestionario_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call cuedet_listar($cuestionario_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('competencia_Id', $r->competencia_Id);
                $res->__SET('pregunta_Id', $r->pregunta_Id);
                $res->__SET('sPreDescripcion', $r->sPreDescripcion);
                $res->__SET('sComNombre', $r->sComNombre);
                $res->__SET('competenciadetalle_Id', $r->competenciadetalle_Id);
                $res->__SET('sComDetNombre', $r->sComDetNombre);
                $res->__SET('nComDetOrden', $r->nComDetOrden);
                $res->__SET('nComDetPorcentaje', $r->nComDetPorcentaje);
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function guardarCuestionarioTest(Resultado $data){
        try {
            $resultado_id = 0;
            $stm = $this->pdo->prepare("CALL res_crear(?,?,?,?,?,?,?,?,?,?,@resultado_id)");
            $stm->execute(array(
                                 $data->__get('nResEvaluaciondetalle_Id'),
                                 $data->__get('nResEvaluado_Id'),
                                 $data->__get('nResResultado'),
                                 $data->__get('sResFeedback'),
                                 $data->__get('nResEstado'),
                                 $data->__get('nArea_Id'),
                                 $data->__get('nCargo_Id'),
                                 $data->__get('nAno_Id'),
                                 $data->__get('nContratacion_Id'),
                                 $data->__get('nEdad_Id'),
                                 ));            
            
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $resultado_id = $r->resultado_id;
            }
            return $resultado_id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function FinalizarCuestionario($resultado_id){
        try {
            $stm = $this->pdo->prepare("CALL res_finaliza($resultado_id)");
            $stm->execute();
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    //MOSTRAR DATOS DE LOS RESULTADOS

    public function MostrarResultadoIndividual($resultado_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_individual($resultado_id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->Cuestionario);
                $res->__SET('Evaluado', $r->Evaluado);
                $res->__SET('Fecha', $r->Fecha);
                $res->__SET('Estado', $r->Estado);
                $res->__SET('Puntaje', $r->Puntaje);
                $res->__SET('FechaIngreso', $r->FechaIngreso);
                $res->__SET('Area', $r->Area);
                $res->__SET('Cargo', $r->Cargo);
                $res->__SET('Ano', $r->Ano);
                $res->__SET('Contrato', $r->Contrato);
                $res->__SET('Edad', $r->Edad);
                $res->__SET('sResPregunta1', $r->sResPregunta1);
                $res->__SET('sResPregunta2', $r->sResPregunta2);
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //MOSTRAR RESULTADOS DE JEFE
/* 
    public function ListarEvaUsuJefe($Evaluador_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listarevaluados($Evaluador_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Personal', $r->Personal);
                $res->__SET('Puesto', $r->Puesto);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $res->__SET('personal_Id', $r->personal_Id);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function MostrarResultadoIndividualJefe($resultado_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_evaluado($resultado_id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('nResEvaluado_Id', $r->nResEvaluado_Id);
                $res->__SET('sPerContrasena', $r->sPerContrasena);
                $res->__SET('Evaluado', $r->Evaluado);
                $res->__SET('PuestoEvaluado', $r->PuestoEvaluado);
                $res->__SET('Area', $r->Area);
                $res->__SET('FechaReingreso', $r->FechaReingreso);
                $res->__SET('Estado', $r->Estado);
                $res->__SET('PuntajeAuto', $r->PuntajeAuto);
                $res->__SET('PuntajeJefe', $r->PuntajeJefe);
                $res->__SET('PuntajeEvaluados', $r->PuntajeEvaluados);
                $res->__SET('sResFeedback', $r->sResFeedback);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    //nuevo MB cabecera del informe de resultados
    public function MostrarResultadoIndividualJefeRep($Evaluado_Id,$Evaluacion_Id,$Cuestionario_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_ConsolidadoGeneral($Evaluado_Id,$Evaluacion_Id,$Cuestionario_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                //$res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Evaluacion', $r->Evaluacion);
                //$res->__SET('nResEvaluado_Id', $r->nResEvaluado_Id);
                //$res->__SET('sPerContrasena', $r->sPerContrasena);
                $res->__SET('Evaluado', $r->Evaluado);
                $res->__SET('PuestoEvaluado', $r->Puesto);
                $res->__SET('Area', $r->Area);
                $res->__SET('FechaReingreso', $r->Ingreso);
                $res->__SET('Correo', $r->Correo);
                $res->__SET('PuntajeFinal', $r->PuntajeFinal);
                $res->__SET('personal_Id', $r->personal_Id); // TODO: HOY
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    } 
    */

    public function ModificarFeedback($resultado_Id,$sResFeedback){
        try {
            $stm = $this->pdo->prepare("CALL res_feedback($resultado_Id,'$sResFeedback')");
            $stm->execute();
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    
    
}
?>
