<?php
class ResultadoPreguntasModel {
    private $pdo;

    public function __CONSTRUCT() {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL respreguntas_listarC(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $resPer = new ResultadoPreguntas();
                $resPer->__SET('nResPerResultado_Id', $r->nResPerResultado_Id);
                $resPer->__SET('sResPerPregunta1', $r->sResPerPregunta1);
                $resPer->__SET('sResPerPregunta2', $r->sResPerPregunta2);
                $resPer->__SET('nResPerFecha_Act', $r->nResPerFecha_Act);
                $resPer->__SET('nResPerUsuario_Id', $r->nResPerUsuario_Id);
                $result[] = $resPer;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($resultado_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL respreguntas_listarC($resultado_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $resPer = new ResultadoPreguntas();
                $resPer->__SET('nResPerResultado_Id', $r->nResPerResultado_Id);
                $resPer->__SET('sResPerPregunta1', $r->sResPerPregunta1);
                $resPer->__SET('sResPerPregunta2', $r->sResPerPregunta2);
                $resPer->__SET('nResPerFecha_Act', $r->nResPerFecha_Act);
                $resPer->__SET('nResPerUsuario_Id', $r->nResPerUsuario_Id);
                $result[] = $resPer;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(ResultadoPreguntas $data) {
        try {
            $stm = $this->pdo->prepare("CALL respreguntas_crear(?, ?, ?, ?)");
            $stm->execute(array(
                $data->__GET('nResPerResultado_Id'),
                $data->__GET('sResPerPregunta1'),
                $data->__GET('sResPerPregunta2'),
                // $data->__GET('nResPerFecha_Act'),
                $data->__GET('nResPerUsuario_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(ResultadoPreguntas $data) {
        try {
            $stm = $this->pdo->prepare("CALL respreguntas_editar(?, ?, ?, ?, ?)");
            $stm->execute(array(
                $data->__GET('nResPerResultado_Id'),
                $data->__GET('sResPerPregunta1'),
                $data->__GET('sResPerPregunta2'),
                $data->__GET('nResPerFecha_Act'),
                $data->__GET('nResPerUsuario_Id')
            ));

        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

}
?>