<?php    
    require_once 'model/competencia.entidad.php';
    require_once 'model/competencia.model.php';
    require_once 'model/usuario.entidad.php';
    require_once 'model/usuario.model.php';
    require_once 'model/parametro.model.php';
    require_once 'model/parametro.entidad.php';

    class CompetenciaController extends helpers {
        private $competencia_model;
        private $usuario_model;
        private $parametro_model;

        private $a_comportamientos;

        public function __CONSTRUCT(){
            $this->competencia_model = new CompetenciaModel();
            $this->usuario_model = new UsuarioModel();
            $this->parametro_model = new ParametroModel();

            $this->a_comportamientos = [];

        }
        
        public function Index(){
            $parametro = $this->parametro_model->ListarParametros();
            $competencias= $this->competencia_model->Listar();

            require_once 'view/header.php';  
            require_once 'view/webforms/wfacompetencia.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }

        public function FrmGuardarProducto(){
            require_once 'view/webforms/wfacompetenciaa.php'; 
        }
        
        public function FrmEditarCompetencia(){
            $datos = $this->competencia_model->Buscar($_POST['competencia_Id']);
            foreach ($datos as $r):
                require_once 'view/webforms/wfacompetenciaa.php';            
            endforeach;       
        }

        public function getCompetencia($competencia_Id){
            
            $datos= $this->competencia_model->Buscar($competencia_Id);
            $html = "";
            foreach ($datos as $r):
                $html .= " <tbody>
                          <tr>
                             <td>
                                <input type='hidden' name='idCompetencia_Print' id='idCompetencia_Print' value='".$r->__GET('competencia_Id')."'> 
                                Competencia
                             </td>
                             <td>".$r->__GET('sComNombre')."</td>
                          </tr>
                          <tr>
                             <td>Tipo</td>
                             <td>".$r->__GET('sComTipo')."</td>
                          </tr>  
                          <tr>
                             <td>Descripción</td>
                             <td>".$r->__GET('sComDescripcion')."</td>
                          </tr>
                       </tbody>
                     ";
            endforeach;
            return $html;
        }
        public function MostrarCompetencia(){
            echo $this->getCompetencia($_POST['competencia_Id']);
        }

        public function GuardarCompetencia(){
            $result = false;
            $s_posted_json = file_get_contents('php://input');
            $o_post = json_decode($s_posted_json);
            
            $o_competencia = new Competencia();
            $o_competencia->__SET('competencia_Id', $o_post->competencia_Id);
            $o_competencia->__SET('sComNombre', $o_post->sComNombre);
            $o_competencia->__SET('sComTipo', $o_post->sComTipo);
            $o_competencia->__SET('sComDescripcion', $o_post->sComDescripcion);
            
            $o_competencia->__SET('Comportamientos', $o_post->Comportamientos);
            
            if($o_post->competencia_Id){
                $result = $this->competencia_model->EditarCompetencia($o_competencia);  
                $num=1;
            } else {
                $result = $this->competencia_model->GuardarCompetencia($o_competencia);
                $num=0;
            }

            if($result){
                echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    Se guardo correctamente.
                </div>';
                if ($num==1) {
                    echo "<meta http-equiv='refresh' content='0'>";
                }
            } else {
                echo '<div class="alert alert-error alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Ups, algo salió mal.</h4>
                    Hubo un error guardando la competencia.
                </div>';
            }

            
        }
        
        public function EliminarCompetencia(){
            $not = new Competencia();
            $not->__SET('competencia_Id', $_POST['idCompetencia']);
            $this->competencia_model->Eliminar($not);
            echo '<script type="text/javascript">window.location="?c=Competencia&a=Index";</script>';       
        }
        
        public function PDFProducto(){            
            require_once 'view/webforms/PDF/producto.php';
        }
        
        public function Search(){
            print_r(json_encode($this->competencia_model->Buscar($_POST['producto_id']), JSON_PRETTY_PRINT));            
        }

        public function ListarComportamientos(){
            $competencia_Id = $_POST['competencia_Id'];
            $a_comportemientos = $this->competencia_model->ListarComportamientos($competencia_Id);
            echo json_encode($a_comportemientos);
        }

    }
?>