<?php
class CompetenciaModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL com_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $com = new Competencia();
                $com->__SET('competencia_Id', $r->competencia_Id);
                $com->__SET('sComNombre', $r->sComNombre);
                $com->__SET('sComTipo', $r->sComTipo);
                $com->__SET('sComDescripcion', $r->sComDescripcion);

                $result[] = $com;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($com_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL com_listar(".$com_id.")");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $com = new Competencia();
                $com->__SET('competencia_Id', $r->competencia_Id);
                $com->__SET('sComNombre', $r->sComNombre);
                $com->__SET('sComTipo', $r->sComTipo);
                $com->__SET('sComDescripcion', $r->sComDescripcion);
                $result[] = $com;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Search($com_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL com_listar(".$com_id.")");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $com = array(
                    'competencia_Id' => $r->competencia_Id,
                    'sComNombre' => $r->sComNombre,
                    'sComTipo' => $r->sComTipo,
                    'sComDescripcion' => $r->sComDescripcion
                );
                $result[] = $com;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function GuardarCompetencia(Competencia $data){
        try {
            $stm = $this->pdo->prepare("CALL com_crear(?, ?, ?, ?, ?, @com_id)");
            $stm->execute(array(
                                 $data->__get('sComNombre'),
                                 $data->__get('sComTipo'),
                                 $data->__get('sComDescripcion'),
                                 0,
                                 1 // id de usuario del sistema
                                 ));
            
            $generated_id = $stm->fetchColumn();
            $stm->closeCursor();

            foreach($data->__GET('Comportamientos') as $comportamiento){
                if($comportamiento->competenciadetalle_Id == 0){
                    $stm_comportamiento = $this->pdo->prepare("CALL comdet_crear(?, ?, ?, ?)");
                    $stm_comportamiento->execute(array(
                                         $generated_id,
                                         $comportamiento->sComDetNombre,
                                         $comportamiento->sComDetValor,
                                         $comportamiento->nComDetOrden
                                         ));
                }
            }

            return $generated_id != NULL ? $generated_id : 0;

        } catch (Exception $e) {
            die($e->getMessage());
            return false;
        }
    }

    public function EditarCompetencia(Competencia $data){
        try {
            $stm = $this->pdo->prepare("CALL com_editar(?, ?, ?, ?, ?)");
            $stm->execute(array(
                                $data->__get('competencia_Id'),
                                $data->__get('sComNombre'),
                                $data->__get('sComTipo'),
                                $data->__get('sComDescripcion'),
                                0
                                ));

            foreach($data->__GET('Comportamientos') as $comportamiento){
                switch($comportamiento->competenciadetalle_Id){
                    case 0: {
                        $stm_comportamiento = $this->pdo->prepare("CALL comdet_crear(?, ?, ?, ?)");
                        $stm_comportamiento->execute(array(
                                             $data->__get('competencia_Id'),
                                             $comportamiento->sComDetNombre,
                                             $comportamiento->sComDetValor,
                                             $comportamiento->nComDetOrden
                                             ));
                        break;
                    }
                    case -1: {
                        $stm_comportamiento = $this->pdo->prepare("DELETE FROM competenciadetalle WHERE sComDetNombre = ? AND competencia_Id = ?");
                        $stm_comportamiento->execute(array(
                                             $comportamiento->sComDetNombre,
                                             $data->__get('competencia_Id')
                                             ));
                        break;
                        
                    }
                }
                
            }

            return true;
            

        } catch (Exception $e) {
            die($e->getMessage());
            return false;
        }
    }

    public function Eliminar(Competencia $data){
        try {
             $stm = $this->pdo->prepare("CALL com_eliminar(?)");
             $stm->execute(array($data->__get('competencia_Id')));
             
             return true;

        } catch (Exception $e) {
             echo die($e->getMessage());
        }
   }

   public function ListarComportamientos($com_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL comdet_listar(". $com_id. ")");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $com = [
                    "competenciadetalle_Id" =>$r->competenciadetalle_Id,
                    "competencia_Id" => $r->competencia_Id,
                    "sComDetNombre" => $r->sComDetNombre,
                    "sComDetValor" => $r->sComDetValor
                ];

                array_push($result, $com);
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
?>
