<?php
class EvaluacionModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eva_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = new Evaluacion();
                $pro->__SET('evaluacion_Id', $r->evaluacion_Id);
                $pro->__SET('sEvaNombre', $r->sEvaNombre);
                $pro->__SET('dEvaInicio', $r->dEvaInicio);
                $pro->__SET('dEvaFin', $r->dEvaFin);
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    //  public function Listar(){
    //     try {
    //         $result = array();
    //         $stm = $this->pdo->prepare("CALL pro_listar(0)");
    //         $stm->execute();
    //         foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
    //             $pro = new Producto();
    //             $pro->__SET('nProTipo', $r->nProTipo);
    //             $pro->__SET('producto_id', $r->producto_id);
    //             $pro->__SET('sproDescripcion', $r->sproDescripcion);
    //             $pro->__SET('dproFecha_Act', $r->dproFecha_Act);
    //             $pro->__SET('nProUsuario_Id', $r->nProUsuario_Id);

    //             $pro->__SET('Productogrupoelectrogeno_Id', $r->Productogrupoelectrogeno_Id);
    //             $pro->__SET('sTPrMarca', $r->sTPrMarca);
    //             $pro->__SET('sTPrModelo', $r->sTPrModelo);
    //             $pro->__SET('sTPrModeloMotor', $r->sTPrModeloMotor);
    //             $pro->__SET('sTPrPotencia', $r->sTPrPotencia);
    //             $pro->__SET('sTPrAlternador', $r->sTPrAlternador);
    //             $pro->__SET('sTPrTipoGobernacion', $r->sTPrTipoGobernacion);
    //             $pro->__SET('sTPrTipoAspiracion', $r->sTPrTipoAspiracion);
    //             $pro->__SET('nTPrPrimeKVA', $r->nTPrPrimeKVA);
    //             $pro->__SET('nTPrStandByKVA', $r->nTPrStandByKVA);
    //             $pro->__SET('dProFecha_Act', $r->dProFecha_Act);
    //             $pro->__SET('nTPrUsuario_Id', $r->nTPrUsuario_Id);

    //             $pro->__SET('sTPrMarca', $r->sTPrMarca);
    //             $result[] = $pro;
    //         }
    //         return $result;
    //     } catch (Exception $e) {
    //         echo die($e->getMessage());
    //     }
    // }
    public function Buscar($evaluacion_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eva_listar($evaluacion_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = new Evaluacion();
                $pro->__SET('evaluacion_Id', $r->evaluacion_Id);
                $pro->__SET('sEvaNombre', $r->sEvaNombre);
                $pro->__SET('sEvaDescripcion', $r->sEvaDescripcion);
                $pro->__SET('dEvaInicio', $r->dEvaInicio);
                $pro->__SET('dEvaFin', $r->dEvaFin);
                $pro->__SET('nEvaEstado', $r->nEvaEstado);
                $pro->__SET('nEvaOculto', $r->nEvaOculto);
                $pro->__SET('dEvaFecha_Act', $r->dEvaFecha_Act);
                $pro->__SET('nEvaUsuario_Id', $r->nEvaUsuario_Id);
                // $pro->__SET('porcAuto', $r->porcAuto);
                // $pro->__SET('porcJefe', $r->porcJefe);
                // $pro->__SET('porcSub', $r->porcSub);
                // $pro->__SET('porcPar', $r->porcPar);
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Search($producto_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pro_listar($producto_id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = array(
                    'nProTipo' => $r->nProTipo,
                    'producto_id' => $r->producto_id,
                    'sproDescripcion' => $r->sproDescripcion,
                    'dproFecha_Act' => $r->dproFecha_Act,
                    'nProUsuario_Id' => $r->nProUsuario_Id,

                    'Productogrupoelectrogeno_Id' => $r->Productogrupoelectrogeno_Id,
                    'sTPrMarca' => $r->sTPrMarca,
                    'sTPrModelo' => $r->sTPrModelo,
                    'sTPrModeloMotor' => $r->sTPrModeloMotor,
                    'sTPrPotencia' => $r->sTPrPotencia,
                    'sTPrAlternador' => $r->sTPrAlternador,
                    'sTPrTipoGobernacion' => $r->sTPrTipoGobernacion,
                    'sTPrTipoAspiracion' => $r->sTPrTipoAspiracion,
                    'nTPrPrimeKVA' => $r->nTPrPrimeKVA,
                    'nTPrStandByKVA' => $r->nTPrStandByKVA,
                    'dProFecha_Act' => $r->dProFecha_Act,
                    'nTPrUsuario_Id' => $r->nTPrUsuario_Id,

                    'sTPrMarca' => $r->sTPrMarca
                );
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Crear(Evaluacion $data){
        try {
            $stm = $this->pdo->prepare("CALL eva_crear(?,?,?,?,?,?,?, @evaluacion_Id)");
            $stm->execute(array(
                                 $data->__get('sEvaNombre'),
                                 $data->__get('sEvaDescripcion'),
                                 date('Y-m-d', strtotime($data->__get('dEvaInicio'))),
                                 date('Y-m-d', strtotime($data->__get('dEvaFin'))),
                                 $data->__get('nEvaEstado'),
                                 $data->__get('nEvaOculto'),
                                 $data->__get('nEvaUsuario_Id'),
                                //  $data->__get('porcAuto'),
                                //  $data->__get('porcJefe'),
                                //  $data->__get('porcSub'),
                                //  $data->__get('porcPar')
                                 ));

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $evaluacion_Id = $r->evaluacion_Id;
            }
            
            return $evaluacion_Id;

        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Editard(Evaluacion $data){
        try {
            $stm = $this->pdo->prepare("CALL pro_editar(?,?,?)");
            $stm->execute(array(
                                 $data->__get('producto_id'),
                                 $data->__get('sproDescripcion'),
                                 $data->__get('nProUsuario_Id')
                                 
                                 ));
            
//            echo '<div class="alert alert-success alert-dismissable">
//                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
//                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
//                    Se modifico correctamente.
//                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(Evaluacion $data){
        try {
             $stm = $this->pdo->prepare("CALL eva_ocultar(?,?)");
             $stm->execute(array($data->__get('evaluacion_Id'), $data->__get('nEvaUsuario_Id')));
             //echo "Se elimino correctamente";
        } catch (Exception $e) {
             echo die($e->getMessage());
        }
   }

   public function Editar(Evaluacion $data){
        try {
            $stm = $this->pdo->prepare("CALL eva_editar(?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('evaluacion_Id'),
                                 $data->__get('sEvaNombre'),
                                 $data->__get('sEvaDescripcion'),
                                 date('Y-m-d', strtotime($data->__get('dEvaInicio'))),
                                 date('Y-m-d', strtotime($data->__get('dEvaFin'))),
                                 $data->__get('nEvaEstado'),
                                 $data->__get('nEvaOculto'),
                                 $data->__get('nEvaUsuario_Id'),
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    //enviar correos

    public function ObtenerEvaluados($evaluacion_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL eva_anunciar($evaluacion_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = new Evaluacion();
                $pro->__SET('personal_Id', $r->personal_Id);
                $pro->__SET('Evaluador', $r->Evaluador);
                $pro->__SET('Correo', $r->Correo);
                $pro->__SET('Clave', $r->Clave);
                $pro->__SET('Puesto', $r->Puesto);
                $pro->__SET('Evaluacion', $r->Evaluacion);
                $pro->__SET('Inicio', $r->Inicio);
                $pro->__SET('Fin', $r->Fin);
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function AnunciarEvaluacion($Evaluador, $asunto, $Correo, $mensaje){
        require_once 'view/librerias/PHPMailer/PHPMailerAutoload.php';
        $mail = new PHPMailer();

        $mail->isSMTP();
        $mail->Debugoutput = 'html';
        $mail->Host = "mail.mbgestionhumana.com";
        $mail->Port = 465;
        $mail->SMTPAuth = true;
        $mail->SMTPSecure = 'ssl';
        $mail->Username = "avisosyalertas@fmsac.com";
        $mail->Password = "Avisos*2024";
        $mail->setFrom('avisosyalertas@fmsac.com', 'Sistema de Evaluación - Delfin Group');
        $mail->CharSet  = 'UTF-8'; // the same as 'utf-8'
        $mail->addReplyTo('avisosyalertas@fmsac.com', 'Sistema de Evaluación - Delfin Group');
        $mail->addAddress($Correo,  $Evaluador);
        //$mail->AddCC($params);
        //$mail->AddBCC("alertas@modasa.com.pe"); // Copia oculta
        $mail->IsHTML(true);
        $mail->Subject = $asunto;
        $mail->msgHTML($mensaje);
        $mail->AltBody = $mensaje;
        if (!$mail->send()) {
            echo '<div class="content-header">
                        <div class="alert alert-danger" role="alert" style="margin-bottom: 0px;">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                            <strong>Mensaje Error!</strong>, '.$mail->ErrorInfo.'.
                        </div>
                  </div>';
        }
    }

}
?>
