// LLENADO DE TABLA
let detalles = [];

function FrmGuardarEvaluacion() {
    $.post('?c=Evaluacion&a=FrmGuardarEvaluacion', {
    }, function (data) {
        $(".content-wrapper").html(data);
    });
}

function agregarFila() {
    // Obtén los valores de los campos seleccionados
    var cuestionarioId = $('#nEvaDetCuestionario_Id').val();
    var cuestionarioText = $('#nEvaDetCuestionario_Id option:selected').text();
    var personalId = $('#nEvaDetEvaluado_Id').val();
    var personalText = $('#nEvaDetEvaluado_Id option:selected').text();

    // Verifica que ambos campos estén seleccionados
    if (cuestionarioId !== "" && personalId !== "") {
        // Crea una nueva fila
        var nuevaFila = `
            <tr>
                <td data_id_detalle="0" style="display: none;">0</td>
                <td data-id_evaluado="${personalId}">${personalText}</td>
                <td data-id_cuestionario="${cuestionarioId}">${cuestionarioText}</td>
                <td>
                    <button type="button" class="btn btn-danger btnEliminar">Eliminar</button>
                </td>
            </tr>
        `;

        // Agrega la nueva fila a la tabla
        $('#tbodyeva').append(nuevaFila);

        // Oculta el mensaje vacío (si está visible)
        $('#mensajeVacio').hide();
    } else {
        // Si no se seleccionaron los campos, muestra un mensaje de error o alerta
        alert("Por favor, seleccione tanto el cuestionario como el personal.");
    }
}


// Función para guardar la evaluación
function GuardarEvaluacion() {
    const detalles = [];
     // Recolectar los datos de la cabecera
     const evaluacion_Id = $('#evaluacion_Id').val();
     const sEvaNombre = $('#sEvaNombre').val();
     const sEvaDescripcion = $('#sEvaDescripcion').val();
     const dEvaInicio = $('#dEvaInicio').val();
     const dEvaFin = $('#dEvaFin').val();
     const nEvaEstado = $('#nEvaEstado').val();

     // Recolectar los detalles de la tabla (detalles del carrito)
     var cantidad_detalles = $('#tbodyeva').children().length;

     for (var j = 0; j < cantidad_detalles; j++) {
        const evaluadoId = $('#tbodyeva').children()[j].children[1].getAttribute('data-id_evaluado')
        const cuestionarioId = $('#tbodyeva').children()[j].children[2].getAttribute('data-id_cuestionario');
        const evaluaciondetalleId = $('#tbodyeva').children()[j].children[0].innerHTML.replace(/\s+/g, '').trim()

        // const existeEvaluado = detalles.some(detalle => detalle.evaluadoId === evaluadoId)
        // if (existeEvaluado) {
        //     alert('El evaluado ya existe en el detalle')
        //     return
        // }

        detalles.push({
            evaluadoId: evaluadoId,  // ID del evaluado
            cuestionarioId: cuestionarioId,  // ID del cuestionario
            evaluaciondetalleId: evaluaciondetalleId
        });
    }
     
     // Validar que los datos sean correctos
     if (!sEvaNombre || !sEvaDescripcion || !dEvaInicio || !dEvaFin || !nEvaEstado) {
         alert("Por favor, complete todos los campos de la cabecera.");
         return;
     }
 
     if (detalles.length === 0) {
         alert("Por favor, agregue al menos un detalle.");
         return;
     }


    var detalles_borrados = initial_detalles_tabla.filter(function(inicialDetalle) {
        return !detalles.some(function(detalle) {
            return detalle.evaluaciondetalleId === inicialDetalle.evaluaciondetalleId
        })
    })
 
     // Crear el objeto con la cabecera y los detalles
     const data = {
         evaluacion_Id,
         sEvaNombre,
         sEvaDescripcion,
         dEvaInicio,
         dEvaFin,
         nEvaEstado,
         detalles,
         detalles_borrados
     };

    // Enviar los datos al backend mediante POST
    $.ajax({
        url: '?c=Evaluacion&a=GuardarEvaluacion',
        type: 'POST',
        contentType: 'application/json',
        data: JSON.stringify(data),
        success: function (response) {
            try {
                const result = JSON.parse(response);
                if (result.status === "success") {
                    alert("Evaluación guardada correctamente.");
                    window.location.href = "?c=Evaluacion&a=Index";
                } else {
                    alert("Error: " + result.message);
                }
            } catch (error) {
                console.error("Error al analizar la respuesta JSON:", response);
                alert("La respuesta del servidor no es válida. Por favor, inténtelo de nuevo.");
            }
        },
        error: function () {
            alert("Ocurrió un error al guardar la evaluación.");
        }
    });
}


function FrmEditarEvaluacionC(evaluacion_Id) {
    $.post('?c=Evaluacion&a=FrmEditarEvaluacion', {
        evaluacion_Id: evaluacion_Id
    }, function (data) {
        $(".content-wrapper").html(data);
    });
}

function quitar_detalle(id) {
	$('#row_detalle_' + id).remove();
}
