<!-- view/webevaluador/wfapreguntasGenerales.php -->
<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Preguntas Generales</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 20px;
        }
        .pregunta {
            margin-bottom: 20px;
        }
        label {
            display: block;
            margin-top: 5px;
        }
        select {
            padding: 5px;
            width: 200px;
        }
        .btn {
            padding: 10px 20px;
            background-color: #28a745;
            color: white;
            border: none;
            border-radius: 5px;
            cursor: pointer;
        }
        .btn:hover {
            background-color: #218838;
        }
    </style>
</head>
<body>
    <h1>Preguntas Generales</h1>
    <form id="formPreguntasGenerales">
        <?php for ($i = 1; $i <= 5; $i++): ?>
            <div class="pregunta">
                <label for="pregunta<?php echo $i; ?>">Pregunta <?php echo $i; ?>:</label>
                <select name="pregunta<?php echo $i; ?>" id="pregunta<?php echo $i; ?>">
                    <option value="">Seleccione una opción</option>
                    <option value="1">Muy de acuerdo</option>
                    <option value="2">De acuerdo</option>
                    <option value="3">Neutral</option>
                    <option value="4">En desacuerdo</option>
                    <option value="5">Muy en desacuerdo</option>
                </select>
            </div>
        <?php endfor; ?>
        <button type="button" id="btnSiguiente" class="btn">Siguiente</button>
    </form>

    <script>
        document.getElementById('btnSiguiente').addEventListener('click', function() {
            const selects = document.querySelectorAll('#formPreguntasGenerales select');
            let isValid = true;

            // Validar que todas las preguntas tengan una respuesta seleccionada
            selects.forEach(select => {
                if (!select.value) {
                    isValid = false;
                    alert('Por favor, responde todas las preguntas.');
                    return;
                }
            });

            if (isValid) {
                // Redirigir a la página de preguntas normales
                window.location.href = 'index.php?c=Controller&action=AplicarCuestionarioTest&step=preguntas_normales';
            }
        });
    </script>
</body>
</html>